#include <xlic/licensing.h>

#include <xlic/client.hpp>
#include <xtl/exception.hpp>

extern "C" int xlic_request_license(const char * socket_filename, const char * name, const char * username, const char * password) {
	try {
		xlic::client(socket_filename).request_license(name, username, password);
		return 0;
	} catch (const xlic::invalid_license_name &) {
		return XLIC_RESULT_INVALIDNAME;
	} catch (const xlic::invalid_userauth &) {
		return XLIC_RESULT_INVALIDUSERAUTH;
	} catch (const xlic::client_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xtl::unix_socket_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xlic::result_code & result) {
		return int(result);
	} catch (...) {}
	return -1;
}
