#include <xlic/licensing.h>

#include <xlic/client.hpp>
#include <xtl/exception.hpp>

extern "C" int xlic_set_system_name(const char * socket_filename, const char * system_name) {
	try {
		xlic::client(socket_filename).set_system_name(system_name);
		return 0;
	} catch (const xlic::client_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xtl::unix_socket_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xlic::result_code & code) {
		return int(code);
	} catch (...) {}
	return -1;
}
