#include <xlic/licensing.h>

#include <xlic/client.hpp>
#include <xtl/exception.hpp>
#include <memory>

extern "C" int xlic_system_name(const char * socket_filename, char ** result) {
	try {
		const auto system_name = xlic::client(socket_filename).system_name();
		const auto size = system_name.length() + 1;
		if (void * ptr = malloc(size)) {
			memcpy(ptr, system_name.c_str(), size);
			*result = static_cast<char *>(ptr);
			return 0;
		}
	} catch (const xlic::client_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xtl::unix_socket_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xlic::result_code & code) {
		return int(code);
	} catch (...) {}
	return -1;
}
