#include <xlic/get_system_name.hpp>

#include <xlic/worker.hpp>

namespace xlic {

get_system_name::get_system_name(
	xlic::session * session,
	xlic::worker & worker,
	xlic::request_id request_id
)
: task(session, worker, request_id)
, m_system_name(m_worker.system_name())
{
	m_worker.completed(this);
}

void get_system_name::write_result(xtl::ostream & stream) {
	stream << xlic::packet_size(xlic::packet_header_size + m_system_name.size());
	stream << xlic::packet_type::system_name;
	stream << m_request_id;
	stream << m_system_name;
}

} // namespace xlic
